% y=example_signal(n)
% y=example_signal(n,a,b,c,d,e)
%
% return an example signal of length n
% if coefficients a, b, c, d, and e are specified, use those
% to get a linear combination of a sharp spike, white noise,
% a step function, a smooth periodic spline, and non-smooth periodic
% function.

function y=example_signal(n,a,b,c,d,e)

x=(0:n-1)/n;

if nargin==1
   a=1;
   b=0.02;
   c=0.5;
   d=1;
   e=0.3;
end

y=a*exp(-abs(x-0.5)*2) ...
 +b*randn(1,n) ...
 +c*(x<0.3) ...
 +d*(x.^2-2/3*x.^3-5/3*(x.^4-4/5*x.^5)) ...
 +e*(sqrt(abs(sin(30*x))));

y=y';
